// NumberOfPoemLines.jsx
//
// Подсчёт стихотворных строк
// Предполагается, что стихотворная строка -- это или однострочный абзац, или строка, в конце которой есть разрыв строки (Shift+Enfer).
// На указанных пользователем страницах анализируются все строки. Критерием строки является наличие одного из знаков набора mySearchedBreaks,
// предваряемого одним из символов набора mySearchedCharacters. 
// Поскольку после тире должна быть отбивка, то не исключено, что эта отбивка может оказаться перед знаком перевода строки.
// Поэтому программа терпимо относится к случайно оставленным одиночным пробелам в конце строки,
// возможно, есть еще случаи, когда в конце стихотворной строки допустим один (но только один!) пробел.
// Проверка на наличие такого возможного пробела выполняется операндом (\\s?) в строке mySearchedCharacters.
// При верстке стихов одно четверостишие от другого обычно отбивают нажатием клавиши перевода строки.
// Появляющиеся при этом пустые строки не учитываются при подсчете числа строк текста.
// Повторяющиеся в конце текстовой цепочки переводы строки, пробелы и пробельные шпации  удаляются. Это не влияет на вид верстки.
// Учитываются только строки, стиль которых совпадает с одним из стилей абзаца, помещенных пользователем в правый столбец меню.
// Для переноса стиля из одного столбца в другой надо или щёлкнуть дважды на названии стиля,
// или, выделив стиль одним щелчком, нажать на кнопку [ >> ] (для переноса в правый столбец) 
// или на кнопку [ << ] (для возврата в левый столбец).
// Когда стиль абзаца найденной строки совпадает с одним из выбранных пользователем, счетчик строк увеличивается на единицу.
//
//  Диалог построен на базе учебного скрипта WorkWithMenu.jsx, сделанного Борисом Кащеевым.
//
// Adobe InDesign CS3, CS4, CS5.
// 
// © Михаил Иванюшин, 2010.   ivanyushin#yandex.ru

var myCurrentVersionData_xx_xx_xx = "17.04.2010";
var myProgramTitul = "Подсчёт числа стихотворных строк (" + myCurrentVersionData_xx_xx_xx + ")  ";
//  Исходные массивы:
var myArray1=[];
var myArray2=[];

mySearchedCharacters = '(\\d|[\\l\\u]|~e|\\)|\\]|\\}|\\-|~_|~=|~-|~~|~{|~}|«|»|~[|~]|~"|~\'|>|[.,:;!?*+=/])(\\s?)';
mySearchedBreaks = '(\\r|\\n)';
//mySearchedBreaks = '(\\r|\\n|~M|~R|~P|~L|~E|~k)';
myEndPoemLineSearchSample = mySearchedCharacters + mySearchedBreaks;
//     \\d     - цифра
//    [\\l\\u] - прописная или строчная буква
//    ~e     - многоточие
//    \\)      - закрывающая круглая скобка
//    \\]      - закрывающая квадратная скобка
//    \\}     - закрывающая фигурная скобка
//    \\-     - перенос
//    ~_    - тире
//    ~=   - минус
//    ~-    - дискреционный перенос
//    ~~    - неразрывный перенос
//    ~{    - открывающая двойная кавычка
//    ~}    - закрывающая двойная кавычка
//    ~[    - открывающая одиночная кавычка
//    ~]    - закрывающая одиночная кавычка
//    ~"   - обычная двойная кавычка
//    ~\'   - обычная одиночная кавычка
//     >    - знак 'больше' (иногда используется как закрывающая скобка)
//  [.,:;!?*+=/] - знаки пунктуации и всякие неучтенные ранее символы
/////////////////////////////////
//    \\r|\\n|~M|~R|~P|~L|~E|~k - варианты окончания строки, разрыва фрейма, колонки, страницы

getDialog = function(myAr1, myAr2,myLastNumber) { // dialog
var w = new Window( 'dialog','     Подсчёт числа стихотворных строк ('+ myCurrentVersionData_xx_xx_xx +')',undefined, {resizeable:false, maximizeButton:false, minimizeButton:false} );
w.orientation = 'column';
w.listPnl = w.add('panel', undefined, 'Поместите в правую колонку cтили, которыми оформлены стихи');
w.listPnl.orientation = 'row';
// Добавляем первый список в панель
w.listPnl.listBox1 = w.listPnl.add( 'listbox', [0, 0, 260, 200] );
var items1=new Array;
// Заполняем первый список
for(var i=0; i<myAr1.length; i++) { items1[i] = w.listPnl.listBox1.add( 'item', myAr1[i]) }
// Добавляем группу кнопок в панель
var g = w.listPnl.add( 'group' );
g.orientation = 'column';
// Добавляем кнопку 'Слева направо'
w.listPnl.leftrightButton=g.add( 'button', undefined, ' >> ' );
// Реакция на нажатие:
w.listPnl.leftrightButton.onClick = function() {
	var sel1 = w.listPnl.listBox1.selection;
	if(sel1 != null) {
		w.listPnl.listBox2.add('item', sel1);
		w.listPnl.listBox1.remove(sel1); 
		}
} //function
// Добавляем кнопку 'Справа налево'
w.listPnl.rightleftButton=g.add( 'button', undefined, ' << ' );
// Реакция на нажатие:
w.listPnl.rightleftButton.onClick = function() {
var sel2 = w.listPnl.listBox2.selection;
	if(sel2 != null) {
		w.listPnl.listBox1.add('item', sel2);
		w.listPnl.listBox2.remove(sel2); 
		}
} //function
// Добавляем в панель второй список
w.listPnl.listBox2 = w.listPnl.add( 'listbox', [0, 0, 260, 200]);
var items2=new Array;
// Реакция на двойной щелчок в первом списке
w.listPnl.listBox1.onDoubleClick = function() {
	var sel1 = w.listPnl.listBox1.selection;
	if(sel1 != null)  {
		w.listPnl.listBox2.add('item', sel1);
		w.listPnl.listBox1.remove(sel1); }
} // function
// Реакция на двойной щелчок во втором списке
w.listPnl.listBox2.onDoubleClick = function() {
var sel2 = w.listPnl.listBox2.selection;
if(sel2 != null) {
	w.listPnl.listBox1.add('item', sel2);
	w.listPnl.listBox2.remove(sel2); 
	}
} // function

w.myLines = w.add('group', undefined, '');
w.myNmrs = w.add('group', undefined, '');
w.myNmrs.alignChildren = "left";		
w.myNmrs.orientation = "row";
w.myNmrs.l = w.myLines.add('group');
w.myNmrs.m = w.myLines.add('group');
w.myNmrs.r = w.myLines.add('group');
w.myNmrs.l.st = w.myNmrs.add('statictext', undefined, "Номер первой страницы");
w.myNmrs.l.et = w.myNmrs.add('edittext', [50, 5, 100, 25], '1');	
w.myNmrs.r.st = w.myNmrs.add('statictext', undefined, "Номер последней страницы");
w.myNmrs.r.et = w.myNmrs.add('edittext', [50, 5, 100, 25], myLastNumber);	

// ——————————————————————
//Добавляем кнопки OK и Cancel как группу объектов окна w
//——————————————————————
var g = w.add( 'group' );
w.okButton = g.add( 'button', undefined, 'OK' );
w.okButton.onClick = function() {
this.window.close( 1 );
}
w.canButton = g.add( 'button', undefined, 'Cancel' );
w.canButton.onClick = function() {
this.window.close( 2 );
}
return w;
} // dialog
// ========= Основная программа ===========
var mySelection = app.selection[0];   
var myNumberOfPoemLines = 0;
var myCurrPageNumber = 0;
var myFoundSamples = new Array;
var myTextInCurrentFrame;
var myCounterOfTextFrames;
var myParaStyleOfFoundSamples;
var myChar;
var myUsedParaStylesInLine;
var myInfoColorSample = new Array;
// myInfoColorSample — шаблон цвета для myColorForMarkPoemLines
//myInfoColorSample = [0, 100, 100, 0]; 
myInfoColorSample = [0, 0, 0, 100]; 
var myParaStyleNames = new Array;
var myColor;
var myName;
myColorName = "myColorForMarkPoemLines";
///////////////////////////////////////////////////////////
if (app.documents.length != 0) { // doc
	var myDoc = app.documents[0];
	if (myDoc.paragraphStyles.length < 3) {alert ("Нет созданных пользователем стилей.",myProgramTitul); exit();}	
	for (i=2; i< myDoc.paragraphStyles.length; i++) { myParaStyleNames.push(myDoc.paragraphStyles.item(i).name) } // перечень всех стилей документа, кроме [Basic Paragraph]
	var w = getDialog(myParaStyleNames, myArray2,myDoc.pages.length);
	w.center();
	if ( w.show() == 1 ) { // show 
		myArray2 = w.listPnl.listBox2.items;
		if (myArray2.length == 0) {alert ("Не выбраны стили.",myProgramTitul); exit();}
		
		var myStartNumber = Number(w.myNmrs.l.et.text);
		var myEndNumber = Number(w.myNmrs.r.et.text);
		if ((myStartNumber < 1) || (myEndNumber < 1))  {alert ("Номер страницы не может быть отрицательным или равным нулю.",myProgramTitul); exit();}		
		if ((myStartNumber > myDoc.pages.length) || (myEndNumber > myDoc.pages.length))   {alert ("Указан несуществующий номер страницы.",myProgramTitul); exit();}		
		if (myStartNumber > myEndNumber)  {alert ("Конечный номер страницы меньше начального.",myProgramTitul); exit();}
		
		var myUsedParaStylesInLine = myArray2.toString(); // массив имен выбранных объединен в одну строку для последующего поиска
		var myUsedParaStylesForInfoArray = myUsedParaStylesInLine.split(',');
		var myUsedParaStylesForInfo = myUsedParaStylesForInfoArray.join("\n   ");
///////////////////////////////////
		try { myDoc.colors.item(myColorName).remove(); } // если такой цвет случайно остался, он удаляется 
		catch (e)  { a=0; }
		try{ 
			myColor = myDoc.colors.item(myColorName).name;
		}  
		catch (myError) { 
			myColor = myDoc.colors.add ({name:myColorName, model:ColorModel.process, space:ColorSpace.CMYK, colorValue:myInfoColorSample}); 
		} 
		var myDate = new Date;
		var myHour = myDate.getHours();
		var myMinutes = myDate.getMinutes();
		var mySecondes = myDate.getSeconds();	
		myProgressPanel = myCreateProgressPanel(myDoc.pages.length, "     " +myProgramTitul + "                                                             http://adobeindesign.ru"); // параметром прогресс-бара будет число страниц документа
		for ( j= 0; j < myDoc.pages.length; j++) { // Pages 
			if (j+1 < myStartNumber) continue; // пока не дошли до страницы начала подсчета строк
			if (j+1 > myEndNumber) break; // заданный диапазон пройден
			myCounterOfTextFrames = myDoc.pages[j].textFrames.length;
			for (t = 0; t < myCounterOfTextFrames; t++) { // Frames
				myTextInCurrentFrame = myDoc.pages[j].textFrames[t];
				if (myTextInCurrentFrame.characters.length == 0) continue; // пустые фреймы пропускаются  
				if (myTextInCurrentFrame.characters[-1].fillColor.name == myColorName) break; // строки этого текстового фрейма уже учтены
				myTextInCurrentFrame.select();	
				myLocalParentStory = myTextInCurrentFrame.parentStory;
				if (myLocalParentStory.overflows == true)  { // 
					alert("Обнаружено переполнение в текстовой цепочке, проходящей через страницу " +myCurrPageNumber,myProgramTitul);
					exit();
				}  //
				// ...удаляются пробелы/пробельные шпации в конце статьи...//
				app.findGrepPreferences.findWhat = '\\s';	
				do {
						myFoundSamples = myLocalParentStory.characters.lastItem().findGrep(); 
						if (myFoundSamples.length != 0)  {
							myLocalParentStory.characters.lastItem().remove(); 
							myLocalParentStory.recompose();
						}
				}	
				while (myFoundSamples.length != 0);
				//......//
				app.findGrepPreferences = NothingEnum.nothing;
				app.findGrepPreferences.findWhat = myEndPoemLineSearchSample;				
				myFoundSamples = myLocalParentStory.findGrep();
				for (k = 0; k < myFoundSamples.length; k++) { // FoundSample
					if (myFoundSamples[k].parentTextFrames[0].parent.name != myCurrPageNumber) { // next stepByStep
						myCurrPageNumber = Number(myFoundSamples[k].parentTextFrames[0].parent.name);
						myStepByStep(myProgressPanel,myCurrPageNumber);
					}  // next stepByStep
					if ((myCurrPageNumber >= myStartNumber) && (myCurrPageNumber <= myEndNumber)) { // S-C-E
						myParaStyleOfFoundSamples = myFoundSamples[k].appliedParagraphStyle;
						if (myUsedParaStylesInLine.search(myParaStyleOfFoundSamples.name) != -1) { myNumberOfPoemLines++;  myFoundSamples[k].fillColor = myColorName;  }
					}  // S-C-E
					else { continue; }
				} // FoundSample
			// Проверка в рамках { FoundSample } потенциально может потерять последнюю стихотворную строку, 
			// если её последний знак -- это не знак перевода строки (или разрыва фрейма/колонки и пр.).
			// Для контроля этой потери нужны дополнительные шаги.
				app.findGrepPreferences = NothingEnum.nothing;
				app.findGrepPreferences.findWhat = mySearchedBreaks;	
				myChar = myLocalParentStory.characters.lastItem();
				myFoundSamples = myChar.findGrep();
				if (myFoundSamples.length == 1) break; // был найден какой-то из знаков перевода/разрыва строки или один из символов перехода в следующий фрейм, колонку, страницу...
				else { // last line without Enter
					app.findGrepPreferences.findWhat = mySearchedCharacters;	
					myFoundSamples = myChar.findGrep();	
					if (myFoundSamples.length == 0) break; // последний знак фрейма или статьи не входит в перечень искомых знаков	
					myColor = myChar.fillColor;
					if (myColor.name == myColorName) break; // эта строка была учтена раньше          
					myParaStyleOfFoundSamples = myChar.appliedParagraphStyle;
					if (myUsedParaStylesInLine.search(myParaStyleOfFoundSamples.name) != -1 ) { // count++
						myNumberOfPoemLines++; myChar.fillColor = myColorName; 
					} // count++
				} // last line without Enter
			myLocalParentStory.characters.itemByRange(0,-1).fillColor = myColorName; // строки этой статьи уже учтены
			} // Frames
		} // Pages
		var myDate = new Date;
		var myHourFinis = myDate.getHours();
		var myMinutesFinis = myDate.getMinutes();
		var mySecondesFinis = myDate.getSeconds();
		var myMinutesOverflow = 0;
		var mySecondesOverflow = 0;
		myHourFinis = myHourFinis - myHour;
		myMinutesFinis = myMinutesFinis - myMinutes;
		mySecondesFinis = mySecondesFinis - mySecondes;
		if (mySecondesFinis <0) { 
			myMinutesFinis--;	
			if (mySecondesFinis != 0) { mySecondesFinis = 60 + mySecondesFinis; }
		} 
		if (myMinutesFinis < 0)  {
			myHourFinis--;
			if (myMinutesFinis != 0) { myMinutesFinis = 60 + myMinutesFinis; }
		} 
		if (myHourFinis <10) myHourFinis = "0" + myHourFinis;
		if (myMinutesFinis <10) myMinutesFinis = "0" + myMinutesFinis;
		if (mySecondesFinis <10) mySecondesFinis = "0" + mySecondesFinis;	
		myProgressPanel.hide();
		myDoc.colors.item(myColorName).remove(); // цвет маркировки найденных строк теперь не нужен
		alert ("\nНачальная страница: " + myStartNumber + ", конечная страница: " + myEndNumber +
		".\n\nВыбранные стили:\n   " + myUsedParaStylesForInfo + "\n\n" + "Число строк, оформленных этими стилями: " +myNumberOfPoemLines +
		"\n\nВремя работы программы [ч:м:с]: "  + myHourFinis +":"  + myMinutesFinis + ":" + mySecondesFinis+
		".\n\n\nhttp://adobeindesign.ru\n\n",myProgramTitul);
		exit();	   	
	} // show
} // doc
else{
   alert ("Нет открытых документов.",myProgramTitul);
	exit();	   
	}
///
function myCreateProgressPanel(myMaximumValue,myInfoProgressLine) { 
//var myProgressPanel = new Window('window', myInfoProgressLine,undefined, {resizeable:false, maximizeButton:false, minimizeButton:false} );
var myProgressPanel = new Window('window', myInfoProgressLine);
with(myProgressPanel){
	myProgressPanel.myProgressBar = add('progressbar', [12, 12, 900, 24], 0, myMaximumValue);
	myProgressPanel.show();
	myProgressbarShow = true;
}
return myProgressPanel;
} 
////
function myStepByStep(myProgressPanel,myProgressIndex) { 
myProgressPanel.myProgressBar.value = myProgressIndex; 
return;
}
///